import java.io.OutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.Arrays;
import java.io.BufferedWriter;
import java.util.HashMap;
import java.util.InputMismatchException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Stream;
import java.util.Map;
import java.io.Writer;
import java.io.OutputStreamWriter;
import java.util.Optional;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 *
 * @author lewin
 */
public class levenshtein_count_lewin {
    public static void main(String[] args) {
        InputStream inputStream = System.in;
        OutputStream outputStream = System.out;
        InputReader in = new InputReader(inputStream);
        OutputWriter out = new OutputWriter(outputStream);
        LevenshteinCount solver = new LevenshteinCount();
        solver.solve(1, in, out);
        out.close();
    }

    static class LevenshteinCount {
        int mod = 998244353 ;
        String s;

        List<Integer> transition(List<Integer> inp, char cur) {
            List<Integer> r = new ArrayList<>();
            r.add(inp.get(0) + 1);
            for (int i = 1; i <= s.length(); i++) {
                int mn = AUtils.min(inp.get(i - 1), inp.get(i), r.get(i - 1)) + 1;
                if (cur == s.charAt(i - 1)) mn = Math.min(mn, inp.get(i - 1));
                r.add(mn);
            }
            return r;
        }

        public void solve(int testNumber, InputReader in, OutputWriter out) {
            s = in.next();
            int d = in.nextInt();

            Map<List<Integer>, Integer> dp = new HashMap<>();
            List<Integer> r = new ArrayList<>();
            for (int i = 0; i <= s.length(); i++) r.add(i);
            dp.put(r, 1);
            long[] ans = new long[1];
            for (int strlen = 0; strlen <= s.length() + d; strlen++) {
                Map<List<Integer>, Integer> ndp = new HashMap<>();
                dp.forEach((k, v) -> {
                    if (k.get(s.length()) == d)
                        ans[0] = (ans[0] + v) % mod;
                    for (char nchar = 'A'; nchar <= 'Z'; nchar++) {
                        List<Integer> nxt = transition(k, nchar);
                        Integer w = ndp.get(nxt);
                        if (w == null) w = 0;
                        ndp.put(nxt, (w + v) % mod);
                    }
                });
                dp = ndp;
            }
            out.println(ans[0]);
        }

    }

    static class AUtils {
        public static <E extends Comparable<E>> E min(E... arr) {
            return Arrays.stream(arr).min(E::compareTo).get();
        }

    }

    static class OutputWriter {
        private final PrintWriter writer;

        public OutputWriter(OutputStream outputStream) {
            writer = new PrintWriter(new BufferedWriter(new OutputStreamWriter(outputStream)));
        }

        public OutputWriter(Writer writer) {
            this.writer = new PrintWriter(writer);
        }

        public void close() {
            writer.close();
        }

        public void println(long i) {
            writer.println(i);
        }

    }

    static class InputReader {
        private InputStream stream;
        private byte[] buf = new byte[1 << 16];
        private int curChar;
        private int numChars;

        public InputReader(InputStream stream) {
            this.stream = stream;
        }

        public int read() {
            if (this.numChars == -1) {
                throw new InputMismatchException();
            } else {
                if (this.curChar >= this.numChars) {
                    this.curChar = 0;

                    try {
                        this.numChars = this.stream.read(this.buf);
                    } catch (IOException var2) {
                        throw new InputMismatchException();
                    }

                    if (this.numChars <= 0) {
                        return -1;
                    }
                }

                return this.buf[this.curChar++];
            }
        }

        public int nextInt() {
            int c;
            for (c = this.read(); isSpaceChar(c); c = this.read()) {
                ;
            }

            byte sgn = 1;
            if (c == 45) {
                sgn = -1;
                c = this.read();
            }

            int res = 0;

            while (c >= 48 && c <= 57) {
                res *= 10;
                res += c - 48;
                c = this.read();
                if (isSpaceChar(c)) {
                    return res * sgn;
                }
            }

            throw new InputMismatchException();
        }

        public String next() {
            int c;
            while (isSpaceChar(c = this.read())) {
                ;
            }

            StringBuilder result = new StringBuilder();
            result.appendCodePoint(c);

            while (!isSpaceChar(c = this.read())) {
                result.appendCodePoint(c);
            }

            return result.toString();
        }

        public static boolean isSpaceChar(int c) {
            return c == 32 || c == 10 || c == 13 || c == 9 || c == -1;
        }

    }
}

